bits	16
org		0
jmp	main
times 0x0b-($-$$) db 0
%include ".\ArchSpecific\x86\bootloader\include\fat_boot_sector.asm"
%include ".\ArchSpecific\x86\bootloader\include\real_mode_floppy.asm"
%include ".\ArchSpecific\x86\bootloader\include\real_mode_print.asm"
bsAdditional           DB "Standard Thontelix Quartz Operating System Bootloader", 0
bsErrorMsg             DB 0x0A,0x0D, "System file 'qloader' can not be found.", 0
bsLoaderFileName       DB "QLOADER    "
main: ;Start
    xchg bx, bx
    cli
    xor ax, ax
    mov ss, ax
    mov sp, 0x7C00; The first instructions will not be executed anyway after this...
    sti
    mov ax, 0x07C0
    mov ds, ax
    mov si, bsAdditional
    call print
    mov WORD [bufloc], 0x1500
    push 32
    push 1
    call ReadSectors
    ;Search for QLOADER
    xor dx, dx
    xor ax, ax
    mov ds, ax
    mov si, 0x3900 ;ds:si = 0:0x3900
    mov ax, 0x07C0
    mov es, ax
    mov di, bsLoaderFileName ;es:di = 0x07C0:(string location)
    findloop:
    mov cx, 11
    push si
    push di
    repz cmpsb
    jz found
    pop di
    pop si
    inc dx
    add si, 0x20
    cmp dx, 0xE0;224
    jnz findloop
    ;Not found
    mov ax, 0x07C0
    mov ds, ax
    mov si, bsErrorMsg
    call print
    cli
    hlt
    found:
    mov ax, 0x07C0
    mov ds, ax
    mov WORD [bufloc], 0x8000
    xor bx, bx
    mov ds, bx
    ;Entry is in SI
    add si, 15 ;First sector
    mov ax, WORD [si] ;AX contains the sector
    LoadToMem:
    mov bx, ax
    add bx, 31
    push ax
    push 1
    push bx
    mov ax, 0x07C0
    mov ds, ax
    call ReadSectors
    xor bx, bx
    mov ds, bx
    pop ax
    add WORD [bufloc], 0x200
    ;Now find the next sector.
    xor dx, dx
    mov cx, 2
    div cx
    test dx, dx
    jz even_entry
    ;odd entry
    mov dx, 3
    mul dx
    mov bx, ax
    mov ax, word [bx+0x1501]
    shr bx, 4
    cmp bx, 0xFF0
    jl LoadToMem
    even_entry:
    mov dx, 3
    mul dx
    mov bx, ax
    mov ax, word [bx+0x1500]
    and ax, 0x0FFF
    cmp ax, 0xFF0
    jl LoadToMem
    DoneLoad:
    push 0x0000
    push 0x8000
    retf
times 510-($-$$) db 0
dw 0xAA55
